<?php

namespace Drupal\mcapi_credcom\Plugin\Derivative;

use Drupal\mcapi\Entity\Workflow as McWorkflow;
use Drupal\Core\Plugin\Discovery\ContainerDeriverInterface;
use Drupal\Component\Plugin\Derivative\DeriverBase;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Provides local tasks to the transact/ page for remote-only workflows
 */
class TransactionFormTasks extends DeriverBase implements ContainerDeriverInterface {

  /**
   * {@inheritDoc}
   */
  public static function create(ContainerInterface $container, $base_plugin_id) {
    return new static();
  }

  /**
   * {@inheritDoc}
   * Make a default tab for the main views
   */
  public function getDerivativeDefinitions($base_plugin_definition) {
    $mcTypes = McWorkflow::loadMultiple();
    usort(
      $mcTypes,
      function ($a, $b){return $a->label <=> $b->label;}
    );
    $w = 0;
    foreach ($mcTypes as $id => $workflow) {
      /** @var \CreditCommons\Workflow $workflow */
      $this->derivatives['mcapi.remote.' . $workflow->id] = [
        'title' => $workflow->label,
        'description' => '',
        'route_name' => 'entity.mc_transaction.add_form',
        'route_parameters' => [
          'mc_workflow' => $workflow->id
        ],
        'base_route' => 'entity.mc_transaction.add_form',
        'weight' => $w++,
      ] + $base_plugin_definition;
    }
    return $this->derivatives;
  }

}
