<?php

namespace Drupal\mcapi_credcom;

use Drupal\Core\Entity\Routing\DefaultHtmlRouteProvider;
use Drupal\Core\Entity\EntityTypeInterface;
use Symfony\Component\Routing\Route;

/**
 * Adds a translate route to the transaction Type entity
 */
class TransactionTypeRouteProvider extends DefaultHtmlRouteProvider {

  /**
   * {@inheritDoc}
   */
  public function getRoutes(EntityTypeInterface $entity_type) {
    $route_collection = parent::getRoutes($entity_type);

    // Route for viewing all wallets for one entity.
    // N.B. Currently there is no link to this route.
    $route = new Route($entity_type->getLinkTemplate('translate-form'));
    $route->setDefaults([
      '_entity_form' => 'mc_workflow.translate_form'
    ])
      ->setRequirement('_permission', 'manage mcapi')
      ->setOptions([
        'parameters' => [
          'mc_workflow' => [
            'type' => "entity:mc_workflow",
          ],
        ],
      ]);
    $route_collection->add("entity.mc_workflow.translate_form", $route);
    return $route_collection;
  }

}
