<?php

namespace Drupal\mcapi_credcom;

use Drupal\Core\Entity\EntityInterface;

/**
 * Defines a class to build a listing of Workflow config entities.
 *
 */
class WorkflowListBuilder extends \Drupal\mcapi\Entity\ListBuilder\WorkflowListBuilder {

  /**
   * {@inheritDoc}
   */
  public function buildHeader() {
    return parent::buildHeader() + ['scope' => $this->t('Scope')];
  }

  /**
   * {@inheritDoc}
   */
  public function buildRow(EntityInterface $entity) {
    // @todo in fact scopes can be anything from trunk to the twig
    return parent::buildRow($entity) +[
      'scope' => [
        'data' => [
          '#markup' => $entity->local ? t('Local') : t('Remote')
        ]
      ]
    ];
  }
}
