<?php

namespace Drupal\mcapi_forms\Entity;

use Drupal\Core\Entity\Routing\DefaultHtmlRouteProvider;
use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\Core\Config\Config;
use Symfony\Component\Routing\Route;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\mcapi\Functions;

/**
 * Provides routes for the wallet entity.
 */
class McFormRouteProvider extends DefaultHtmlRouteProvider {

  protected $config;

  /**
   * Constructs a new DefaultHtmlRouteProvider.
   */
  public function __construct($entity_type_manager, $entity_field_manager, Config $config) {
    parent::__construct($entity_type_manager, $entity_field_manager);
    $this->config = $config;
  }

  /**
   * {@inheritDoc}
   */
  public static function createInstance(ContainerInterface $container, EntityTypeInterface $entity_type) {
    return new static(
      $container->get('entity_type.manager'),
      $container->get('entity_field.manager'),
      $container->get('config.factory')->get('mcapi.settings')
    );
  }

  /**
   * {@inheritDoc}
   */
  public function getRoutes(EntityTypeInterface $entity_type) {
    $route_collection = parent::getRoutes($entity_type);
    return $route_collection;
  }

}


/*
entity.mc_form.edit_form:
  path: '/admin/accounting/form/edit/{mc_form}'
  defaults:
    _entity_form: mc_form.edit
    _title: 'Design transaction form'
  requirements:
    _permission: 'configure mcapi'
  options:
    _admin_route: TRUE

entity.mc_form.add_form:
  path: '/admin/accounting/form/create'
  defaults:
    _entity_form: mc_form.add
    _title: 'Design transaction form'
  requirements:
    _permission: 'configure mcapi'
  options:
    _admin_route: TRUE
*/
