<?php
namespace Drupal\mcapi_forms\EventSubscriber;

use Drupal\mcapi_forms\Entity\McForm;
use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;
use Symfony\Component\Routing\Route;

/**
 * Subscriber to create a router item for each transaction form display.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritDoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    $hide_default_tabs = \Drupal::config('mcapi_forms.settings')->get('hide_default_transaction_tabs');
    foreach (McForm::loadMultiple() as $mcForm) {
      $route = new Route(
        $mcForm->getPath(),
        ['_entity_form' => 'mc_transaction.designed'],
        ['_entity_create_access' => 'mc_transaction'],
      );
      if ($hide_default_tabs) {
        //hide the default transaction forms from normal users
        $route->addRequirements(['_permission' => 'manage mcapi']);
      }
      $collection->add('mcapi_forms.add_transaction.'.$mcForm->id(), $route);
    }
  }

}

