<?php

namespace Drupal\mcapi_forms\Plugin\Derivative;

use Drupal\mcapi_forms\Entity\McForm;
use Drupal\Core\Plugin\Discovery\ContainerDeriverInterface;
use Drupal\Component\Plugin\Derivative\DeriverBase;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Provides local actions to create smallads of each type.
 */
class TransactionFormTasks extends DeriverBase implements ContainerDeriverInterface {

  /**
   * {@inheritDoc}
   */
  public static function create(ContainerInterface $container, $base_plugin_id) {
    return new static(
      $container->get('entity_type.manager')
    );
  }

  /**
   * {@inheritDoc}
   * Make a top level tab for each of this modules forms.
   */
  public function getDerivativeDefinitions($base_plugin_definition) {
    $forms = McForm::loadMultiple();
    // Put the forms in order of the menu weight
    usort(
      $forms,
      function ($a, $b){return $a->menu['weight'] <=> $b->menu['weight'];}
    );
    $w=0;
    foreach ($forms as $mc_form) {
      if (!empty($mc_form->hasTransactionTab())) {
        $this->derivatives['mcapi_forms.tabs.'.$mc_form->id()] = [
          'title' => $mc_form->menu['title'],
          'description' => '',
          'route_name' => 'mcapi_forms.add_transaction.'.$mc_form->id(),
          'base_route' => 'entity.mc_transaction.add_form',
          'weight' => $w++,
        ] + $base_plugin_definition;
      }
    }
    return $this->derivatives;
  }

}
