<?php

namespace Drupal\mcapi_limits\Plugin\Limits;

use Drupal\mcapi_limits\Plugin\McapiLimitsBase;
use Drupal\mcapi\Entity\WalletInterface;
use \Drupal\Core\Form\FormStateInterface;

/**
 * No balance limits.
 *
 * @Limits(
 *   id = "explicit",
 *   label = @Translation("Explicit"),
 *   description = @Translation("Explicit limits")
 * )
 */
class Explicit extends McapiLimitsBase {

  /**
   * {@inheritDoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    return [
      'min' => [
        '#type' => 'worth',
        '#description' => $this->t('Blank means no limit.'),
        '#default_value' => $this->configuration['min'] ?? 1000,
      ],
      'max' => [
        '#type' => 'worth',
        '#description' => $this->t('Blank means no limit.'),
        '#default_value' => $this->configuration['max'] ?? 1000,
      ]
    ];
  }

  /**
   * {@inheritDoc}
   */
  public function max(WalletInterface $wallet) : int {
    return $this->configuration['max'];
  }

  /**
   * {@inheritDoc}
   */
  public function min(WalletInterface $wallet) : int {
    return -$this->configuration['min'];
  }


  /**
   * {@inheritDoc}
   */
  public function defaultConfiguration() {
    $defaults = parent::defaultConfiguration();
    $defaults = [
      'min' => -1000,
      'max' => 1000,
    ];
    return $defaults;
  }

}
