<?php

namespace Drupal\mcapi_limits\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;

/**
 * Supports validating payer & payee of parent transactions.
 *
 * @Constraint(
 *   id = "limits_min",
 *   label = @Translation("Checks that neither wallet goes beyond its determined credit limits"),
 *   type = "entity:mc_transaction"
 * )
 */
class TransactionLimitMinConstraint extends Constraint {

  public $message = "The transaction would take wallet '%wallet' %excess below its minimum limit of %limit.";
  public int $diff;
  public int $wid;

  /**
   * {@inheritDoc}
   */
  public function coversFields() {
    return ['entries'];
  }

  public function validatedBy() {
    return '\Drupal\mcapi_limits\Plugin\Validation\Constraint\TransactionLimitsConstraintValidator';
  }

}
