<?php

namespace Drupal\mcapi\Element;

use Drupal\Core\Render\Element\RenderElement;

/**
 * Provides an element rendering transactions as sentence
 *
 * @RenderElement("entry_sentence")
 */
class EntrySentence extends RenderElement {

  /**
   * {@inheritDoc}
   */
  public function getInfo() {
    return [
      '#mc_entry' => NULL,
      '#template' => '',
      '#pre_render' => [
        [static::class, 'preRender'],
      ],
    ];
  }

  public static function preRender($element) {
    $element['#markup'] = \Drupal::token()->replace(
      str_replace('[', '[entry:', $element['#template']),
      ['entry' => $element['#mc_entry']]
    );
    return $element;
  }

}
