<?php

namespace Drupal\mcapi\Entity\Access;

use Symfony\Component\Routing\Route;
use Drupal\Core\Routing\RouteMatchInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityAccessCheck;

/**
 * Access to route user/{user}/wallets
 * @note not currently used
 */
class EntityWalletsAccess extends EntityAccessCheck {

  /**
   * {@inheritDoc}
   */
  public function view(Route $route, RouteMatchInterface $route_match, AccountInterface $account) {

    $result = AccessResult::allowed()->cachePerUser();
    if ($account->hasPermission('manage mcapi') || $account->hasPermission('view all wallets')) {
      return $result;
    }
    $user = $route_match->getParameters()->get('user');
    // Can view the wallets if you are the owner.
    if ($user->id() == $account->id()) {
      return $result;
    }
    return $result->forbidden()->cachePerUser();
  }

}
