<?php

namespace Drupal\mcapi\Entity\ListBuilder;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityListBuilder;
use Drupal\Core\Render\Markup;

/**
 * Defines a class to build a listing of Workflow config entities.
 *
 */
class WorkflowListBuilder extends EntityListBuilder {

  /**
   * {@inheritDoc}
   */
  public function buildHeader() {
    // Enable language column and filter if multiple languages are added.
    $header = [
      'name' => [
        'data' => $this->t('Name'),
      ],
      'summary' => $this->t('Summary'),
      'operations' => $this->t('Operations'),
    ];
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritDoc}
   */
  public function buildRow(EntityInterface $entity) {
    $row['name']['data'] = [
      '#markup' => Markup::Create($entity->label())
    ];
    $row['summary']['data'] = [
      '#markup' => Markup::Create($entity->summary)
    ];
    if ($entity->disabled) {
      $row['name']['data']['#prefix'] = '<font color=gray>';
      $row['name']['data']['#suffix'] = '</font>';
    }
    else {
      $row += parent::buildRow($entity);
    }
    return $row;
  }


  protected function getTitle() {
    return $this->t('Workflows');
  }
}
