<?php

namespace Drupal\mcapi\Entity\Query;

use Drupal\Core\Entity\Query\Sql\Query;

/**
 * The SQL storage entity query class.
 *
 * Additional methods to filter Transaction queries.
 */
class TransactionQuery extends Query {

  /**
   * Filter the query to include only transactions in which the given
   * wallet is payer or payee
   *
   * @param int $wallet_id
   * @return \Drupal\mcapi\Entity\TransactionQuery
   */
  public function involving(int $wallet_id) {
    $group = $this->orConditionGroup()
      ->condition('entries.payer_wid', $wallet_id)
      ->condition('entries.payee_wid', $wallet_id);
    $this->condition($group);
    return $this;
  }

}

