<?php

namespace Drupal\mcapi\Entity\Storage;

use Drupal\mcapi\Entity\Wallet;
use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Entity\Sql\SqlContentEntityStorage;

/**
 * Storage controller for wallet entity.
 */
class WalletStorage extends SqlContentEntityStorage implements WalletStorageInterface {

  /**
   * {@inheritDoc}
   */
  public function getQueryServiceName() {
    return 'mc_wallet.query.sql';
  }

  /**
   * {@inheritDoc}
   */
  public function walletsOf(int $uid) : array {
    $wids = \Drupal::entityQuery('mc_wallet')
      ->accessCheck(FALSE) // not to trigger hook_query_mc_wallet_access_alter()
      ->condition('owner', $uid)
      ->execute();
    return $wids;
  }

}

