<?php

namespace Drupal\mcapi\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Entity\RevisionableInterface;
use Drupal\mcapi\Plugin\Field\FieldType\EntryItem;

/**
 * Interface for Transaction entity.
 */
interface TransactionInterface extends ContentEntityInterface, RevisionableInterface {

  function addEntry(array $params) : EntryItem|NULL;

  /**
   * Get all the IDs of all wallets involved in all the transaction entries.
   * @return int[]
   */
  function allWalletIds() : array;

  /**
   * Get the names of all valid transaction states.
   * @return string[]
   */
  static function states() : array;
}
