<?php

namespace Drupal\mcapi\Form;

use Drupal\mcapi\Functions;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Form\ConfirmFormBase;
use Drupal\mcapi\Entity\Transaction;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Confirm form to add all signatures needed by a user.
 *
 * @todo complete this
 * inject TransactionViewBuilder, currentUser
 */
class SignAllConfirm extends ConfirmFormBase {

  /**
   *
   * @var Transaction[]
   */
  protected $unsigned;

  protected $transactionViewBiulder;

  function __construct($current_user, $entity_type_manager) {
    $this->transactionViewBiulder = $entity_type_manager->getViewBuilder('mc_transaction');
    $this->unsigned = Transaction::loadMultiple(Functions::transactionsNeedingSig($current_user->id()));
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('current_user'),
      $container->get('entity_type.manager'),
    );
  }

  /**
   * {@inheritDoc}
   */
  public function getQuestion() {

  }

  /**
   * {@inheritDoc}
   */
  public function getCancelUrl() {

  }

  /**
   * {@inheritDoc}
   */
  public function getFormId() {
    return 'sign_all_confirm';
  }

  /**
   * {@inheritDoc}
   */
  public function form() {
    $this->messenger->addWarning('this page is untested. Whose signatures are we signing? CurrentUser?');

    $unsigned =

    $form['preview'][] = $this->transactionViewBuilder->viewMultiple($this->unsigned, 'sentence');

    $form['account'] = array(
      '#type' => 'value',
      '#value' => $account,
    );
    $form['buttons']['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Sign all'),
    );
    return $form;
  }

  /**
   * {@inheritDoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $values = $form_state->getValues();
    foreach ($this->unsigned as $xid) {
      $transaction = current(Transaction::load($xid));
      $transaction->signatures->signAll();
      $transaction->save();
    }
    $this->messenger()->addStatus(t('All the transactions have been signed.'));
    $form_state->setRedirect('user.page');
  }

}
