<?php

namespace Drupal\mcapi\Plugin\Field\FieldFormatter;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Format the first entry using a theme callback.
 *
 * @FieldFormatter(
 *   id = "mc_entries",
 *   label = @Translation("Pretty entries"),
 *   description = @Translation("Main entry is themed and others are sentences."),
 *   field_types = {
 *     "entry"
 *   }
 * )
 */
class Entries extends EntrySentenceFormatter {

  /**
   * {@inheritDoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = parent::viewElements($items, $langcode);
    $elements[0] = [
      '#theme' => 'mc_main_entry',
      '#mc_entry' => $items->first(),
    ];
    return $elements;
  }

}
