<?php

namespace Drupal\mcapi\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin implementation of the 'mc_signatures' formatter.
 *
 * @FieldFormatter(
 *   id = "mc_signatures",
 *   label = @Translation("Signatures"),
 *   description = @Translation("Signatures with dates."),
 *   field_types = {
 *     "mc_signature"
 *   }
 * )
 */
class Signatures extends FormatterBase {

  /**
   * {@inheritDoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [];
    if ($values = $items->getValue()) {
      $elements = [
        '#theme' => 'mc_signatures',
        '#signatures' => $items->getValue(),
        '#transaction' => $items->getEntity(),
      ];
    }
    return $elements;
  }
}
