<?php

namespace Drupal\mcapi\Plugin\Field\FieldFormatter;

use Drupal\Mcapi\Functions;
use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'mc_signatures' formatter.
 *
 * @FieldFormatter(
 *   id = "mc_worth",
 *   label = @Translation("Signatures"),
 *   description = @Translation("Signatures with dates."),
 *   field_types = {"mc_worth"}
 * )
 */
class Worth extends FormatterBase {

  /**
   * {@inheritDoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    return Functions::formatCurrency($items->quant);
  }


  public function settingsForm(array $form, FormStateInterface $form_state) {
    return [
      'link_to_metrics' => [
        '#type' => 'checkbox',
        '#title' => t('Link to metrics'),
        '#default_value' => $this->getSetting('link_to_metrics')
      ]
    ];
  }

  public function settingsSummary() {
    return [
      '#markup' => $this->getSettings('link_to_metrics') ? $this->t('With link to metrics') : $this->t('Without link to metrics')
    ];
  }
}
