<?php

namespace Drupal\mcapi\Plugin\Validation\Constraint;

use \Drupal\Core\Entity\Plugin\Validation\Constraint\CompositeConstraintBase;

/**
 * Check that the two wallets in the transaction are different.
 *
 * Supports validating payer & payee of parent transactions.
 *
 * @Constraint(
 *   id = "DifferentWallets",
 *   label = @Translation("Checks that the payer and payee wallets are different"),
 * )
 */
class DifferentWalletsConstraint extends CompositeConstraintBase {

  public string $sameMessage = 'The payer and payee wallets must be different';

  /**
   * The wallet ID
   * @var int
   */
  public int $wid;

  /**
   * {@inheritDoc}
   */
  public function coversFields() {
    return ['entries'];
  }

}
