<?php

namespace Drupal\mcapi\Plugin\Validation\Constraint;

use Symfony\Component\Validator\ConstraintValidator;
use Symfony\Component\Validator\Constraint;

/**
 * Every entry must be between different wallets.
 */
class DifferentWalletsConstraintValidator extends ConstraintValidator {

  /**
   * {@inheritDoc}
   */
  public function validate($entries, Constraint $constraint) {
    foreach ($entries as $delta => $entry) {
      if ($entry->payer_wid == $entry->payee_wid) {
        $constraint->wid = $entry->payee_wid;
        $this->context
          ->buildViolation($constraint->sameMessage)
          ->addViolation();
        $this->context
          ->buildViolation($constraint->sameMessage)
          ->addViolation();
      }
    }
  }

}
