<?php

namespace Drupal\mcapi\Plugin\migrate\destination;

use Drupal\migrate\Plugin\migrate\destination\EntityContentBase;
use Drupal\migrate\Row;
use Drupal\user\Entity\User;

/**
 * @MigrateDestination(
 *   id = "entity:mc_wallet"
 * )
 */
class EntityWallet extends EntityContentBase {

  /**
   * {@inheritDoc}
   */
  public function import(Row $row, array $old_destination_id_values = []) {
    // In D7 only users could hold wallets.
    $owner = User::load($row->getDestinationProperty('owner'));
    $row->setDestinationProperty('owner', $owner);
    return parent::import($row, $old_destination_id_values);
  }

}
