<?php

/**
 * @file
 */
namespace Drupal\mcapi\Plugin\migrate\process;

use Drupal\migrate\MigrateExecutableInterface;
use Drupal\migrate\ProcessPluginBase;
use Drupal\migrate\Row;

/**
 * convert the old display setting into the new one-string format
 *
 * @MigrateProcessPlugin(
 *   id = "mc_workflow"
 * )
 */
class TransactionType extends ProcessPluginBase {


  public function __construct(array $configuration, $plugin_id, $plugin_definition) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
    \Drupal::moduleHandler()->loadInclude('mcapi_signatures', 'install');
  }

  /**
   * {@inheritDoc}
   *
   * $value must be a workflow type i.e 3rdparty, default_bill, default_credit.
   */
  public function transform($value, MigrateExecutableInterface $migrate_executable, Row $row, $destination_property) {
    // We don't care what the previous 'type' was ($value) - the meaning has changed.
    return mcapi_type_update(
      $row->getSourceProperty('payee'),
      $row->getSourceProperty('payer'),
      $row->getSourceProperty('creator')
    );
  }

}
