<?php

namespace Drupal\mcapi\Plugin\views\field;

use Drupal\mcapi\Entity\Wallet;
use Drupal\views\ResultRow;
use Drupal\views\Plugin\views\field\FieldPluginBase;
use Drupal\Core\Render\Markup;

/**
 * Field handler provides current stat for given wallet via Wallet::getStatAll.
 *
 * @ingroup views_field_handlers
 *
 * @ViewsField("wallet_stat")
 */
class WalletStat extends FieldPluginBase {

  /**
   * {@inheritDoc}
   */
  public function query() {
    $this->addAdditionalFields();
  }

  /**
   * {@inheritDoc}
   */
  public function render(ResultRow $values) {
    $entity = $this->getEntity($values);
    if ($entity->getEntityTypeId() == 'user') {
      $wids = \Drupal::entityTypeManager()->getStorage('mc_wallet')->walletsOf($entity->id());
      $wallet = Wallet::load(reset($wids));
    }
    elseif ($entity->getEntityTypeId() == 'mc_wallet') {
      $wallet = $entity;
    }
    if ($wallet) {
      $stat = $this->definition['stat'];
      return Markup::create($wallet->{$stat});
    }
  }

}
