<?php

namespace Drupal\mcapi\Plugin\views\field;

use Drupal\mcapi\Entity\Workflow;
use Drupal\views\Plugin\views\field\FieldPluginBase;
use Drupal\views\ResultRow;

/**
 * Field handler for the name of the transaction type.
 *
 * @ingroup views_field_handlers
 *
 * @ViewsField("mc_workflow")
 */
class Workflow extends FieldPluginBase {

  /**
   * {@inheritDoc}
   */
  public function render(ResultRow $values) {
    $raw = $this->getValue($values);
    return ['#markup' => '<span class = "mc-type-'. $raw .'">' . Workflow::load($raw)->label() . '</span>'];
  }

}
